/[gentoo-x86]/eclass/webapp.eclass
Gentoo

Diff of /eclass/webapp.eclass

Parent Directory Parent Directory | Revision Log Revision Log | View Patch Patch

Revision 1.49 Revision 1.72
1# Copyright 1999-2006 Gentoo Foundation 1# Copyright 1999-2011 Gentoo Foundation
2# Distributed under the terms of the GNU General Public License v2 2# Distributed under the terms of the GNU General Public License v2
3# $Header: /var/cvsroot/gentoo-x86/eclass/webapp.eclass,v 1.49 2008/02/22 09:33:45 hollow Exp $ 3# $Header: /var/cvsroot/gentoo-x86/eclass/webapp.eclass,v 1.72 2012/07/18 14:59:29 blueness Exp $
4# 4
5# @ECLASS: webapp.eclass 5# @ECLASS: webapp.eclass
6# @MAINTAINER: 6# @MAINTAINER:
7# web-apps@gentoo.org 7# web-apps@gentoo.org
8# @BLURB: functions for installing applications to run under a web server 8# @BLURB: functions for installing applications to run under a web server
9# @DESCRIPTION: 9# @DESCRIPTION:
10# The webapp eclass contains functions to handle web applications with 10# The webapp eclass contains functions to handle web applications with
11# webapp-config. Part of the implementation of GLEP #11 11# webapp-config. Part of the implementation of GLEP #11
12 12
13# @ECLASS-VARIABLE: WEBAPP_DEPEND
14# @DESCRIPTION:
15# An ebuild should use WEBAPP_DEPEND if a custom DEPEND needs to be built, most
16# notably in combination with WEBAPP_OPTIONAL.
17WEBAPP_DEPEND=">=app-admin/webapp-config-1.50.15"
18
19# @ECLASS-VARIABLE: WEBAPP_NO_AUTO_INSTALL
20# @DESCRIPTION:
21# An ebuild sets this to `yes' if an automatic installation and/or upgrade is
22# not possible. The ebuild should overwrite pkg_postinst() and explain the
23# reason for this BEFORE calling webapp_pkg_postinst().
24
25# @ECLASS-VARIABLE: WEBAPP_OPTIONAL
26# @DESCRIPTION:
27# An ebuild sets this to `yes' to make webapp support optional, in which case
28# you also need to take care of USE-flags and dependencies.
29
30if [[ "${WEBAPP_OPTIONAL}" != "yes" ]]; then
31 [[ "${WEBAPP_NO_AUTO_INSTALL}" == "yes" ]] || IUSE="vhosts"
13SLOT="${PVR}" 32 SLOT="${PVR}"
14IUSE="vhosts" 33 DEPEND="${WEBAPP_DEPEND}"
15DEPEND=">=app-admin/webapp-config-1.50.15"
16RDEPEND="${DEPEND}" 34 RDEPEND="${DEPEND}"
35fi
17 36
18EXPORT_FUNCTIONS pkg_postinst pkg_setup src_install pkg_prerm 37EXPORT_FUNCTIONS pkg_postinst pkg_setup src_install pkg_prerm
19 38
20INSTALL_DIR="/${PN}" 39INSTALL_DIR="/${PN}"
21IS_UPGRADE=0 40IS_UPGRADE=0
22IS_REPLACE=0 41IS_REPLACE=0
23 42
24INSTALL_CHECK_FILE="installed_by_webapp_eclass" 43INSTALL_CHECK_FILE="installed_by_webapp_eclass"
44SETUP_CHECK_FILE="setup_by_webapp_eclass"
25 45
26ETC_CONFIG="${ROOT}/etc/vhosts/webapp-config" 46ETC_CONFIG="${ROOT}etc/vhosts/webapp-config"
27WEBAPP_CONFIG="${ROOT}/usr/sbin/webapp-config" 47WEBAPP_CONFIG="${ROOT}usr/sbin/webapp-config"
28WEBAPP_CLEANER="${ROOT}/usr/sbin/webapp-cleaner" 48WEBAPP_CLEANER="${ROOT}usr/sbin/webapp-cleaner"
29 49
30# ============================================================================== 50# ==============================================================================
31# INTERNAL FUNCTIONS 51# INTERNAL FUNCTIONS
32# ============================================================================== 52# ==============================================================================
33 53
34# Load the config file /etc/vhosts/webapp-config 54# Load the config file /etc/vhosts/webapp-config
35# Supports both the old bash version, and the new python version 55# Supports both the old bash version, and the new python version
36webapp_read_config() { 56webapp_read_config() {
57 debug-print-function $FUNCNAME $*
58
37 if has_version '>=app-admin/webapp-config-1.50'; then 59 if has_version '>=app-admin/webapp-config-1.50'; then
38 ENVVAR=$(${WEBAPP_CONFIG} --query ${PN} ${PVR}) || die "Could not read settings from webapp-config!" 60 ENVVAR=$(${WEBAPP_CONFIG} --query ${PN} ${PVR}) || die "Could not read settings from webapp-config!"
39 eval ${ENVVAR} 61 eval ${ENVVAR}
40 else 62 elif [[ "${WEBAPP_OPTIONAL}" != "yes" ]]; then
63 # ETC_CONFIG might not be available
41 . ${ETC_CONFIG} || die "Unable to read ${ETC_CONFIG}" 64 . ${ETC_CONFIG} || die "Unable to read ${ETC_CONFIG}"
65 elif [[ -f "${ETC_CONFIG}" ]]; then
66 # WEBAPP_OPTIONAL is set to yes
67 # and this must run only if ETC_CONFIG actually exists
68 . ${ETC_CONFIG} || die "Unable to read ${ETC_CONFIG}"
42 fi 69 fi
43} 70}
44 71
45# Check whether a specified file exists in the given directory (`.' by default) 72# Check whether a specified file exists in the given directory (`.' by default)
46# or not.
47webapp_checkfileexists() { 73webapp_checkfileexists() {
48 local my_prefix 74 debug-print-function $FUNCNAME $*
49 75
50 [ -n "${2}" ] && my_prefix="${2}/" || my_prefix= 76 local my_prefix=${2:+${2}/}
51 77
52 if [ ! -e "${my_prefix}${1}" ]; then 78 if [[ ! -e "${my_prefix}${1}" ]]; then
53 msg="ebuild fault: file '${1}' not found" 79 msg="ebuild fault: file '${1}' not found"
54 eerror "$msg" 80 eerror "$msg"
55 eerror "Please report this as a bug at http://bugs.gentoo.org/" 81 eerror "Please report this as a bug at http://bugs.gentoo.org/"
56 die "$msg" 82 die "$msg"
57 fi 83 fi
58} 84}
59 85
60webapp_check_installedat() { 86webapp_check_installedat() {
87 debug-print-function $FUNCNAME $*
61 ${WEBAPP_CONFIG} --show-installed -h localhost -d "${INSTALL_DIR}" 2> /dev/null 88 ${WEBAPP_CONFIG} --show-installed -h localhost -d "${INSTALL_DIR}" 2> /dev/null
62} 89}
63 90
64webapp_strip_appdir() { 91webapp_strip_appdir() {
65 local my_stripped="${1}" 92 debug-print-function $FUNCNAME $*
66 echo "${1}" | sed -e "s|${MY_APPDIR}/||g;" 93 echo "${1#${MY_APPDIR}/}"
67} 94}
68 95
69webapp_strip_d() { 96webapp_strip_d() {
70 echo "${1}" | sed -e "s|${D}||g;" 97 debug-print-function $FUNCNAME $*
98 echo "${1#${D}}"
71} 99}
72 100
73webapp_strip_cwd() { 101webapp_strip_cwd() {
74 local my_stripped="${1}" 102 debug-print-function $FUNCNAME $*
75 echo "${1}" | sed -e 's|/./|/|g;' 103 echo "${1/#.\///}"
104}
105
106webapp_getinstalltype() {
107 debug-print-function $FUNCNAME $*
108
109 if ! has vhosts ${IUSE} || use vhosts; then
110 return
111 fi
112
113 local my_output
114 my_output="$(webapp_check_installedat)"
115
116 if [[ $? -eq 0 ]]; then
117 # something is already installed there
118 # make sure it isn't the same version
119
120 local my_pn="$(echo ${my_output} | awk '{ print $1 }')"
121 local my_pvr="$(echo ${my_output} | awk '{ print $2 }')"
122
123 REMOVE_PKG="${my_pn}-${my_pvr}"
124
125 if [[ "${my_pn}" == "${PN}" ]]; then
126 if [[ "${my_pvr}" != "${PVR}" ]]; then
127 elog "This is an upgrade"
128 IS_UPGRADE=1
129 # for binpkgs, reset status, var declared in global scope
130 IS_REPLACE=0
131 else
132 elog "This is a re-installation"
133 IS_REPLACE=1
134 # for binpkgs, reset status, var declared in global scope
135 IS_UPGRADE=0
136 fi
137 else
138 elog "${my_output} is installed there"
139 fi
140 else
141 # for binpkgs, reset status, var declared in global scope
142 IS_REPLACE=0
143 IS_UPGRADE=0
144 elog "This is an installation"
145 fi
76} 146}
77 147
78# ============================================================================== 148# ==============================================================================
79# PUBLIC FUNCTIONS 149# PUBLIC FUNCTIONS
80# ============================================================================== 150# ==============================================================================
81 151
152# @FUNCTION: need_httpd
153# @DESCRIPTION:
154# Call this function AFTER your ebuilds DEPEND line if any of the available
155# webservers are able to run this application.
156need_httpd() {
157 DEPEND="${DEPEND}
158 || ( virtual/httpd-basic virtual/httpd-cgi virtual/httpd-fastcgi )"
159}
160
161# @FUNCTION: need_httpd_cgi
162# @DESCRIPTION:
163# Call this function AFTER your ebuilds DEPEND line if any of the available
164# CGI-capable webservers are able to run this application.
165need_httpd_cgi() {
166 DEPEND="${DEPEND}
167 || ( virtual/httpd-cgi virtual/httpd-fastcgi )"
168}
169
170# @FUNCTION: need_httpd_fastcgi
171# @DESCRIPTION:
172# Call this function AFTER your ebuilds DEPEND line if any of the available
173# FastCGI-capabale webservers are able to run this application.
174need_httpd_fastcgi() {
175 DEPEND="${DEPEND}
176 virtual/httpd-fastcgi"
177}
178
82# @FUNCTION: webapp_configfile 179# @FUNCTION: webapp_configfile
83# @USAGE: <file> [more files ...] 180# @USAGE: <file> [more files ...]
84# @DESCRIPTION: 181# @DESCRIPTION:
85# Mark a file config-protected for a web-based application. 182# Mark a file config-protected for a web-based application.
86webapp_configfile() { 183webapp_configfile() {
184 debug-print-function $FUNCNAME $*
185
87 local m="" 186 local m
88 for m in "$@" ; do 187 for m in "$@"; do
89 webapp_checkfileexists "${m}" "${D}" 188 webapp_checkfileexists "${m}" "${D}"
90 189
91 local MY_FILE="$(webapp_strip_appdir "${m}")" 190 local my_file="$(webapp_strip_appdir "${m}")"
92 MY_FILE="$(webapp_strip_cwd "${MY_FILE}")" 191 my_file="$(webapp_strip_cwd "${my_file}")"
93 192
94 elog "(config) ${MY_FILE}" 193 elog "(config) ${my_file}"
95 echo "${MY_FILE}" >> ${D}/${WA_CONFIGLIST} 194 echo "${my_file}" >> ${D}/${WA_CONFIGLIST}
96 done 195 done
97} 196}
98 197
99# @FUNCTION: webapp_hook_script 198# @FUNCTION: webapp_hook_script
100# @USAGE: <file> 199# @USAGE: <file>
101# @DESCRIPTION: 200# @DESCRIPTION:
102# Install a script that will run after a virtual copy is created, and 201# Install a script that will run after a virtual copy is created, and
103# before a virtual copy has been removed. 202# before a virtual copy has been removed.
104webapp_hook_script() { 203webapp_hook_script() {
204 debug-print-function $FUNCNAME $*
205
105 webapp_checkfileexists "${1}" 206 webapp_checkfileexists "${1}"
106 207
107 elog "(hook) ${1}" 208 elog "(hook) ${1}"
108 cp "${1}" "${D}/${MY_HOOKSCRIPTSDIR}/$(basename "${1}")" || die "Unable to install ${1} into ${D}/${MY_HOOKSCRIPTSDIR}/" 209 cp "${1}" "${D}/${MY_HOOKSCRIPTSDIR}/$(basename "${1}")" || die "Unable to install ${1} into ${D}/${MY_HOOKSCRIPTSDIR}/"
109 chmod 555 "${D}/${MY_HOOKSCRIPTSDIR}/$(basename "${1}")" 210 chmod 555 "${D}/${MY_HOOKSCRIPTSDIR}/$(basename "${1}")"
112# @FUNCTION: webapp_postinst_txt 213# @FUNCTION: webapp_postinst_txt
113# @USAGE: <lang> <file> 214# @USAGE: <lang> <file>
114# @DESCRIPTION: 215# @DESCRIPTION:
115# Install a text file containing post-installation instructions. 216# Install a text file containing post-installation instructions.
116webapp_postinst_txt() { 217webapp_postinst_txt() {
218 debug-print-function $FUNCNAME $*
219
117 webapp_checkfileexists "${2}" 220 webapp_checkfileexists "${2}"
118 221
119 elog "(info) ${2} (lang: ${1})" 222 elog "(info) ${2} (lang: ${1})"
120 cp "${2}" "${D}/${MY_APPDIR}/postinst-${1}.txt" 223 cp "${2}" "${D}/${MY_APPDIR}/postinst-${1}.txt"
121} 224}
123# @FUNCTION: webapp_postupgrade_txt 226# @FUNCTION: webapp_postupgrade_txt
124# @USAGE: <lang> <file> 227# @USAGE: <lang> <file>
125# @DESCRIPTION: 228# @DESCRIPTION:
126# Install a text file containing post-upgrade instructions. 229# Install a text file containing post-upgrade instructions.
127webapp_postupgrade_txt() { 230webapp_postupgrade_txt() {
231 debug-print-function $FUNCNAME $*
232
128 webapp_checkfileexists "${2}" 233 webapp_checkfileexists "${2}"
129 234
130 elog "(info) ${2} (lang: ${1})" 235 elog "(info) ${2} (lang: ${1})"
131 cp "${2}" "${D}/${MY_APPDIR}/postupgrade-${1}.txt" 236 cp "${2}" "${D}/${MY_APPDIR}/postupgrade-${1}.txt"
237}
238
239# helper for webapp_serverowned()
240_webapp_serverowned() {
241 debug-print-function $FUNCNAME $*
242
243 webapp_checkfileexists "${1}" "${D}"
244 local my_file="$(webapp_strip_appdir "${1}")"
245 my_file="$(webapp_strip_cwd "${my_file}")"
246
247 elog "(server owned) ${my_file}"
248 echo "${my_file}" >> "${D}/${WA_SOLIST}"
132} 249}
133 250
134# @FUNCTION: webapp_serverowned 251# @FUNCTION: webapp_serverowned
135# @USAGE: [-R] <file> [more files ...] 252# @USAGE: [-R] <file> [more files ...]
136# @DESCRIPTION: 253# @DESCRIPTION:
137# Identify a file which must be owned by the webserver's user:group settings. 254# Identify a file which must be owned by the webserver's user:group settings.
138# The ownership of the file is NOT set until the application is installed using 255# The ownership of the file is NOT set until the application is installed using
139# the webapp-config tool. If -R is given directories are handled recursively. 256# the webapp-config tool. If -R is given directories are handled recursively.
140webapp_serverowned() { 257webapp_serverowned() {
258 debug-print-function $FUNCNAME $*
259
141 local a="" 260 local a m
142 local m=""
143 if [ "${1}" = "-R" ]; then 261 if [[ "${1}" == "-R" ]]; then
144 shift 262 shift
145 for m in "$@" ; do 263 for m in "$@"; do
146 for a in $(find ${D}/${m}); do 264 find "${D}${m}" | while read a; do
147 a=${a/${D}\/\///}
148 webapp_checkfileexists "${a}" "$D"
149 local MY_FILE="$(webapp_strip_appdir "${a}")" 265 a=$(webapp_strip_d "${a}")
150 MY_FILE="$(webapp_strip_cwd "${MY_FILE}")" 266 _webapp_serverowned "${a}"
151
152 elog "(server owned) ${MY_FILE}"
153 echo "${MY_FILE}" >> "${D}/${WA_SOLIST}"
154 done 267 done
155 done 268 done
156 else 269 else
157 for m in "$@" ; do 270 for m in "$@"; do
158 webapp_checkfileexists "${m}" "$D" 271 _webapp_serverowned "${m}"
159 local MY_FILE="$(webapp_strip_appdir "${m}")"
160 MY_FILE="$(webapp_strip_cwd "${MY_FILE}")"
161
162 elog "(server owned) ${MY_FILE}"
163 echo "${MY_FILE}" >> "${D}/${WA_SOLIST}"
164 done 272 done
165 fi 273 fi
166} 274}
167 275
168# @FUNCTION: webapp_server_configfile 276# @FUNCTION: webapp_server_configfile
171# Install a configuration file for the webserver. You need to specify a 279# Install a configuration file for the webserver. You need to specify a
172# webapp-config supported <server>. if no new name is given `basename $2' is 280# webapp-config supported <server>. if no new name is given `basename $2' is
173# used by default. Note: this function will automagically prepend $1 to the 281# used by default. Note: this function will automagically prepend $1 to the
174# front of your config file's name. 282# front of your config file's name.
175webapp_server_configfile() { 283webapp_server_configfile() {
284 debug-print-function $FUNCNAME $*
285
176 webapp_checkfileexists "${2}" 286 webapp_checkfileexists "${2}"
177 287
178 # sort out what the name will be of the config file 288 # WARNING:
179
180 local my_file
181
182 if [ -z "${3}" ]; then
183 my_file="${1}-$(basename "${2}")"
184 else
185 my_file="${1}-${3}"
186 fi
187
188 # warning:
189 # 289 #
190 # do NOT change the naming convention used here without changing all 290 # do NOT change the naming convention used here without changing all
191 # the other scripts that also rely upon these names 291 # the other scripts that also rely upon these names
292
293 local my_file="${1}-${3:-$(basename "${2}")}"
192 294
193 elog "(${1}) config file '${my_file}'" 295 elog "(${1}) config file '${my_file}'"
194 cp "${2}" "${D}/${MY_SERVERCONFIGDIR}/${my_file}" 296 cp "${2}" "${D}/${MY_SERVERCONFIGDIR}/${my_file}"
195} 297}
196 298
200# Install a SQL script that creates/upgrades a database schema for the web 302# Install a SQL script that creates/upgrades a database schema for the web
201# application. Currently supported database engines are mysql and postgres. 303# application. Currently supported database engines are mysql and postgres.
202# If a version is given the script should upgrade the database schema from 304# If a version is given the script should upgrade the database schema from
203# the given version to $PVR. 305# the given version to $PVR.
204webapp_sqlscript() { 306webapp_sqlscript() {
307 debug-print-function $FUNCNAME $*
308
205 webapp_checkfileexists "${2}" 309 webapp_checkfileexists "${2}"
206 310
207 # create the directory where this script will go 311 dodir "${MY_SQLSCRIPTSDIR}/${1}"
208 #
209 # scripts for specific database engines go into their own subdirectory
210 # just to keep things readable on the filesystem
211 312
212 if [ ! -d "${D}/${MY_SQLSCRIPTSDIR}/${1}" ]; then 313 # WARNING:
213 mkdir -p "${D}/${MY_SQLSCRIPTSDIR}/${1}" || die "unable to create directory ${D}/${MY_SQLSCRIPTSDIR}/${1}"
214 fi
215
216 # warning:
217 # 314 #
218 # do NOT change the naming convention used here without changing all 315 # do NOT change the naming convention used here without changing all
219 # the other scripts that also rely upon these names 316 # the other scripts that also rely upon these names
220 317
221 # are we dealing with an 'upgrade'-type script?
222 if [ -n "${3}" ]; then 318 if [[ -n "${3}" ]]; then
223 # yes we are
224 elog "(${1}) upgrade script from ${PN}-${PVR} to ${3}" 319 elog "(${1}) upgrade script for ${PN}-${3} to ${PVR}"
225 cp "${2}" "${D}${MY_SQLSCRIPTSDIR}/${1}/${3}_to_${PVR}.sql" 320 cp "${2}" "${D}${MY_SQLSCRIPTSDIR}/${1}/${3}_to_${PVR}.sql"
226 chmod 600 "${D}${MY_SQLSCRIPTSDIR}/${1}/${3}_to_${PVR}.sql" 321 chmod 600 "${D}${MY_SQLSCRIPTSDIR}/${1}/${3}_to_${PVR}.sql"
227 else 322 else
228 # no, we are not
229 elog "(${1}) create script for ${PN}-${PVR}" 323 elog "(${1}) create script for ${PN}-${PVR}"
230 cp "${2}" "${D}/${MY_SQLSCRIPTSDIR}/${1}/${PVR}_create.sql" 324 cp "${2}" "${D}/${MY_SQLSCRIPTSDIR}/${1}/${PVR}_create.sql"
231 chmod 600 "${D}/${MY_SQLSCRIPTSDIR}/${1}/${PVR}_create.sql" 325 chmod 600 "${D}/${MY_SQLSCRIPTSDIR}/${1}/${PVR}_create.sql"
232 fi 326 fi
233} 327}
234 328
235# ==============================================================================
236# EXPORTED FUNCTIONS
237# ==============================================================================
238
239# @FUNCTION: webapp_src_install 329# @FUNCTION: webapp_src_preinst
240# @DESCRIPTION: 330# @DESCRIPTION:
241# You need to call this function in src_install() AFTER everything else has run. 331# You need to call this function in src_install() BEFORE anything else has run.
242# For now, we just make sure that root owns everything, and that there are no 332# For now we just create required webapp-config directories.
243# setuid files.
244webapp_src_install() {
245 chown -R "${VHOST_DEFAULT_UID}:${VHOST_DEFAULT_GID}" "${D}/"
246 chmod -R u-s "${D}/"
247 chmod -R g-s "${D}/"
248
249 keepdir "${MY_PERSISTDIR}"
250 fowners "root:0" "${MY_PERSISTDIR}"
251 fperms 755 "${MY_PERSISTDIR}"
252
253 # to test whether or not the ebuild has correctly called this function
254 # we add an empty file to the filesystem
255 #
256 # we used to just set a variable in the shell script, but we can
257 # no longer rely on Portage calling both webapp_src_install() and
258 # webapp_pkg_postinst() within the same shell process
259
260 touch "${D}/${MY_APPDIR}/${INSTALL_CHECK_FILE}"
261}
262
263# @FUNCTION: webapp_pkg_setup
264# @DESCRIPTION:
265# You need to call this function in pkg_config() AFTER everything else has run.
266# If 'vhosts' USE flag is not set, auto-install this app.
267webapp_pkg_setup() {
268 # add sanity checks here
269
270 # special case - some ebuilds *do* need to overwride the SLOT
271 if [[ "${SLOT}+" != "${PVR}+" && "${WEBAPP_MANUAL_SLOT}" != "yes" ]]; then
272 die "Set WEBAPP_MANUAL_SLOT=\"yes\" if you need to SLOT manually"
273 fi
274
275 # pull in the shared configuration file
276
277 G_HOSTNAME="localhost"
278 webapp_read_config
279
280 # are we installing a webapp-config solution over the top of a
281 # non-webapp-config solution?
282
283 if ! use vhosts ; then
284 local my_dir="${ROOT}${VHOST_ROOT}/${MY_HTDOCSBASE}/${PN}"
285 local my_output
286
287 if [ -d "${my_dir}" ] ; then
288 my_output="$(webapp_check_installedat)"
289
290 if [ "$?" != "0" ]; then
291 # okay, whatever is there, it isn't webapp-config-compatible
292 ewarn "You already have something installed in ${my_dir}"
293 ewarn
294 ewarn "Whatever is in ${my_dir}, it's not"
295 ewarn "compatible with webapp-config."
296 ewarn
297 ewarn "This ebuild may be overwriting important files."
298 ewarn
299 elif [ "$(echo ${my_output} | awk '{ print $1 }')" != "${PN}" ]; then
300 eerror "${my_dir} contains ${my_output}"
301 eerror "I cannot upgrade that"
302 die "Cannot upgrade contents of ${my_dir}"
303 fi
304 fi
305 fi
306}
307
308webapp_getinstalltype() {
309 # or are we upgrading?
310
311 if ! use vhosts ; then
312 # we only run webapp-config if vhosts USE flag is not set
313
314 local my_output
315
316 my_output="$(webapp_check_installedat)"
317
318 if [ "${?}" = "0" ] ; then
319 # something is already installed there
320 #
321 # make sure it isn't the same version
322
323 local my_pn="$(echo ${my_output} | awk '{ print $1 }')"
324 local my_pvr="$(echo ${my_output} | awk '{ print $2 }')"
325
326 REMOVE_PKG="${my_pn}-${my_pvr}"
327
328 if [ "${my_pn}" == "${PN}" ]; then
329 if [ "${my_pvr}" != "${PVR}" ]; then
330 elog "This is an upgrade"
331 IS_UPGRADE=1
332 else
333 elog "This is a re-installation"
334 IS_REPLACE=1
335 fi
336 else
337 elog "${my_output} is installed there"
338 fi
339 else
340 elog "This is an installation"
341 fi
342 fi
343}
344
345webapp_src_preinst() { 333webapp_src_preinst() {
346 # create the directories that we need 334 debug-print-function $FUNCNAME $*
347 335
336 # sanity checks, to catch bugs in the ebuild
337 if [[ ! -f "${T}/${SETUP_CHECK_FILE}" ]]; then
338 eerror
339 eerror "This ebuild did not call webapp_pkg_setup() at the beginning"
340 eerror "of the pkg_setup() function"
341 eerror
342 eerror "Please log a bug on http://bugs.gentoo.org"
343 eerror
344 eerror "You should use emerge -C to remove this package, as the"
345 eerror "installation is incomplete"
346 eerror
347 die "Ebuild did not call webapp_pkg_setup() - report to http://bugs.gentoo.org"
348 fi
349
350 # Hint, see the webapp_read_config() function to find where these are
351 # defined.
348 dodir "${MY_HTDOCSDIR}" 352 dodir "${MY_HTDOCSDIR}"
349 dodir "${MY_HOSTROOTDIR}" 353 dodir "${MY_HOSTROOTDIR}"
350 dodir "${MY_CGIBINDIR}" 354 dodir "${MY_CGIBINDIR}"
351 dodir "${MY_ICONSDIR}" 355 dodir "${MY_ICONSDIR}"
352 dodir "${MY_ERRORSDIR}" 356 dodir "${MY_ERRORSDIR}"
353 dodir "${MY_SQLSCRIPTSDIR}" 357 dodir "${MY_SQLSCRIPTSDIR}"
354 dodir "${MY_HOOKSCRIPTSDIR}" 358 dodir "${MY_HOOKSCRIPTSDIR}"
355 dodir "${MY_SERVERCONFIGDIR}" 359 dodir "${MY_SERVERCONFIGDIR}"
356} 360}
357 361
362# ==============================================================================
363# EXPORTED FUNCTIONS
364# ==============================================================================
365
366# @FUNCTION: webapp_pkg_setup
367# @DESCRIPTION:
368# The default pkg_setup() for this eclass. This will gather required variables
369# from webapp-config and check if there is an application installed to
370# `${ROOT}/var/www/localhost/htdocs/${PN}/' if USE=vhosts is not set.
371#
372# You need to call this function BEFORE anything else has run in your custom
373# pkg_setup().
374webapp_pkg_setup() {
375 debug-print-function $FUNCNAME $*
376
377 # to test whether or not the ebuild has correctly called this function
378 # we add an empty file to the filesystem
379 #
380 # we used to just set a variable in the shell script, but we can
381 # no longer rely on Portage calling both webapp_pkg_setup() and
382 # webapp_src_install() within the same shell process
383 touch "${T}/${SETUP_CHECK_FILE}"
384
385 # special case - some ebuilds *do* need to overwride the SLOT
386 if [[ "${SLOT}+" != "${PVR}+" && "${WEBAPP_MANUAL_SLOT}" != "yes" ]]; then
387 die "Set WEBAPP_MANUAL_SLOT=\"yes\" if you need to SLOT manually"
388 fi
389
390 # pull in the shared configuration file
391 G_HOSTNAME="localhost"
392 webapp_read_config
393
394 local my_dir="${ROOT}${VHOST_ROOT}/${MY_HTDOCSBASE}/${PN}"
395
396 # if USE=vhosts is enabled OR no application is installed we're done here
397 if ! has vhosts ${IUSE} || use vhosts || [[ ! -d "${my_dir}" ]]; then
398 return
399 fi
400
401 local my_output
402 my_output="$(webapp_check_installedat)"
403
404 if [[ $? -ne 0 ]]; then
405 # okay, whatever is there, it isn't webapp-config-compatible
406 echo
407 ewarn
408 ewarn "You already have something installed in ${my_dir}"
409 ewarn
410 ewarn "Whatever is in ${my_dir}, it's not"
411 ewarn "compatible with webapp-config."
412 ewarn
413 ewarn "This ebuild may be overwriting important files."
414 ewarn
415 echo
416 if has "${EAPI:-0}" 0 1 2; then
417 ebeep 10
418 fi
419 elif [[ "$(echo ${my_output} | awk '{ print $1 }')" != "${PN}" ]]; then
420 echo
421 eerror "You already have ${my_output} installed in ${my_dir}"
422 eerror
423 eerror "I cannot upgrade a different application"
424 eerror
425 echo
426 die "Cannot upgrade contents of ${my_dir}"
427 fi
428
429}
430
431# @FUNCTION: webapp_src_install
432# @DESCRIPTION:
433# This is the default src_install(). For now, we just make sure that root owns
434# everything, and that there are no setuid files.
435#
436# You need to call this function AFTER everything else has run in your custom
437# src_install().
438webapp_src_install() {
439 debug-print-function $FUNCNAME $*
440
441 # to test whether or not the ebuild has correctly called this function
442 # we add an empty file to the filesystem
443 #
444 # we used to just set a variable in the shell script, but we can
445 # no longer rely on Portage calling both webapp_src_install() and
446 # webapp_pkg_postinst() within the same shell process
447 touch "${D}/${MY_APPDIR}/${INSTALL_CHECK_FILE}"
448
449 chown -R "${VHOST_DEFAULT_UID}:${VHOST_DEFAULT_GID}" "${D}/"
450 chmod -R u-s "${D}/"
451 chmod -R g-s "${D}/"
452
453 keepdir "${MY_PERSISTDIR}"
454 fowners "root:0" "${MY_PERSISTDIR}"
455 fperms 755 "${MY_PERSISTDIR}"
456}
457
458# @FUNCTION: webapp_pkg_postinst
459# @DESCRIPTION:
460# The default pkg_postinst() for this eclass. This installs the web application to
461# `${ROOT}/var/www/localhost/htdocs/${PN}/' if USE=vhosts is not set. Otherwise
462# display a short notice how to install this application with webapp-config.
463#
464# You need to call this function AFTER everything else has run in your custom
465# pkg_postinst().
358webapp_pkg_postinst() { 466webapp_pkg_postinst() {
467 debug-print-function $FUNCNAME $*
468
359 webapp_read_config 469 webapp_read_config
360 470
361 # sanity checks, to catch bugs in the ebuild 471 # sanity checks, to catch bugs in the ebuild
362
363 if [ ! -f "${ROOT}${MY_APPDIR}/${INSTALL_CHECK_FILE}" ]; then 472 if [[ ! -f "${ROOT}${MY_APPDIR}/${INSTALL_CHECK_FILE}" ]]; then
364 eerror 473 eerror
365 eerror "This ebuild did not call webapp_src_install() at the end" 474 eerror "This ebuild did not call webapp_src_install() at the end"
366 eerror "of the src_install() function" 475 eerror "of the src_install() function"
367 eerror 476 eerror
368 eerror "Please log a bug on http://bugs.gentoo.org" 477 eerror "Please log a bug on http://bugs.gentoo.org"
371 eerror "installation is incomplete" 480 eerror "installation is incomplete"
372 eerror 481 eerror
373 die "Ebuild did not call webapp_src_install() - report to http://bugs.gentoo.org" 482 die "Ebuild did not call webapp_src_install() - report to http://bugs.gentoo.org"
374 fi 483 fi
375 484
376 # if 'vhosts' is not set in your USE flags, we install a copy of 485 if has vhosts ${IUSE}; then
377 # this application in ${ROOT}/var/www/localhost/htdocs/${PN}/ for you
378
379 if ! use vhosts ; then 486 if ! use vhosts; then
380 echo 487 echo
381 elog "vhosts USE flag not set - auto-installing using webapp-config" 488 elog "vhosts USE flag not set - auto-installing using webapp-config"
382 489
383 webapp_getinstalltype
384
385 G_HOSTNAME="localhost" 490 G_HOSTNAME="localhost"
386 local my_mode=-I
387 webapp_read_config 491 webapp_read_config
388 492
493 local my_mode=-I
494 webapp_getinstalltype
495
389 if [ "${IS_REPLACE}" = "1" ]; then 496 if [[ "${IS_REPLACE}" == "1" ]]; then
390 elog "${PN}-${PVR} is already installed - replacing" 497 elog "${PN}-${PVR} is already installed - replacing"
391 my_mode=-I 498 my_mode=-I
392 elif [ "${IS_UPGRADE}" = "1" ]; then 499 elif [[ "${IS_UPGRADE}" == "1" ]]; then
393 elog "${REMOVE_PKG} is already installed - upgrading" 500 elog "${REMOVE_PKG} is already installed - upgrading"
394 my_mode=-U 501 my_mode=-U
502 else
503 elog "${PN}-${PVR} is not installed - using install mode"
504 fi
505
506 my_cmd="${WEBAPP_CONFIG} ${my_mode} -h localhost -u root -d ${INSTALL_DIR} ${PN} ${PVR}"
507 elog "Running ${my_cmd}"
508 ${my_cmd}
509
510 echo
511 local cleaner="${WEBAPP_CLEANER} -p -C /${PN}"
512 einfo "Running ${cleaner}"
513 ${cleaner}
395 else 514 else
396 elog "${PN}-${PVR} is not installed - using install mode" 515 elog
516 elog "The 'vhosts' USE flag is switched ON"
517 elog "This means that Portage will not automatically run webapp-config to"
518 elog "complete the installation."
519 elog
520 elog "To install ${PN}-${PVR} into a virtual host, run the following command:"
521 elog
522 elog " webapp-config -I -h <host> -d ${PN} ${PN} ${PVR}"
523 elog
524 elog "For more details, see the webapp-config(8) man page"
397 fi 525 fi
398
399 my_cmd="${WEBAPP_CONFIG} ${my_mode} -h localhost -u root -d ${INSTALL_DIR} ${PN} ${PVR}"
400 elog "Running ${my_cmd}"
401 ${my_cmd}
402
403 # run webapp-cleaner instead of emerge
404 echo
405 local cleaner="${WEBAPP_CLEANER} -p -C ${PN}"
406 einfo "Running ${cleaner}"
407 ${cleaner}
408 else 526 else
409 # vhosts flag is on
410 #
411 # let's tell the administrator what to do next
412
413 elog 527 elog
414 elog "The 'vhosts' USE flag is switched ON" 528 elog "This ebuild does not support the 'vhosts' USE flag."
415 elog "This means that Portage will not automatically run webapp-config to" 529 elog "This means that Portage will not automatically run webapp-config to"
416 elog "complete the installation." 530 elog "complete the installation."
417 elog 531 elog
418 elog "To install ${PN}-${PVR} into a virtual host, run the following command:" 532 elog "To install ${PN}-${PVR} into a virtual host, run the following command:"
419 elog 533 elog
420 elog " webapp-config -I -h <host> -d ${PN} ${PN} ${PVR}" 534 elog " webapp-config -I -h <host> -d ${PN} ${PN} ${PVR}"
421 elog 535 elog
422 elog "For more details, see the webapp-config(8) man page" 536 elog "For more details, see the webapp-config(8) man page"
423 fi 537 fi
424
425 return 0
426} 538}
427 539
540# @FUNCTION: webapp_pkg_prerm
541# @DESCRIPTION:
542# This is the default pkg_prerm() for this eclass. If USE=vhosts is not set
543# remove all installed copies of this web application. Otherwise instruct the
544# user to manually remove those copies. See bug #136959.
428webapp_pkg_prerm() { 545webapp_pkg_prerm() {
429 # remove any virtual installs that there are 546 debug-print-function $FUNCNAME $*
430 547
431 local my_output 548 local my_output=
549 my_output="$(${WEBAPP_CONFIG} --list-installs ${PN} ${PVR})"
550 [[ $? -ne 0 ]] && return
551
432 local x 552 local x
433 553 if has vhosts ${IUSE} && ! use vhosts; then
434 my_output="$(${WEBAPP_CONFIG} --list-installs ${PN} ${PVR})" 554 echo "${my_output}" | while read x; do
435 555 if [[ -f "${x}"/.webapp ]]; then
436 if [ "${?}" != "0" ]; then 556 . "${x}"/.webapp
437 return
438 fi
439
440 if ! use vhosts ; then # remove any installed copies
441
442 for x in ${my_output} ; do
443 [ -f ${x}/.webapp ] && . ${x}/.webapp || ewarn "Cannot find file ${x}/.webapp"
444 if [ "${WEB_HOSTNAME}" -a "${WEB_INSTALLDIR}" ]; then 557 if [[ -n "${WEB_HOSTNAME}" && -n "${WEB_INSTALLDIR}" ]]; then
445 ${WEBAPP_CONFIG} -C -h ${WEB_HOSTNAME} -d ${WEB_INSTALLDIR} 558 ${WEBAPP_CONFIG} -C -h ${WEB_HOSTNAME} -d ${WEB_INSTALLDIR} ${PN} ${PVR}
559 fi
560 else
561 ewarn "Cannot find file ${x}/.webapp"
446 fi 562 fi
447 done 563 done
448 else # don't remove anything, but warn user. bug #136959 564 elif [[ "${my_output}" != "" ]]; then
449 565 echo
566 ewarn
450 ewarn "Don't forget to use webapp-config to remove any copies of" 567 ewarn "Don't forget to use webapp-config to remove any copies of"
451 ewarn "${PN}-${PVR} installed in" 568 ewarn "${PN}-${PVR} installed in"
452 ewarn 569 ewarn
453 570
454 for x in ${my_output} ; do 571 echo "${my_output}" | while read x; do
455 [ -f ${x}/.webapp ] && . ${x}/.webapp || ewarn "Cannot find file ${x}/.webapp" 572 if [[ -f "${x}"/.webapp ]]; then
456 ewarn " ${x}" 573 ewarn " ${x}"
574 else
575 ewarn "Cannot find file ${x}/.webapp"
576 fi
457 done 577 done
578
579 ewarn
580 echo
458 fi 581 fi
459} 582}

Legend:
Removed from v.1.49  
changed lines
  Added in v.1.72

  ViewVC Help
Powered by ViewVC 1.1.20